package com.example.physiotherapytest;

import java.util.Vector;

import android.app.Activity;
import android.graphics.Typeface;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.TextView;
import android.widget.Toast;

public class AdaptadorOWESTRYFuncional extends BaseAdapter {
    private final Activity actividad;
    private final Vector<String> lista;
    private final Boolean[] chequeados;
    private int contador = 0;

    public AdaptadorOWESTRYFuncional(Activity actividad, Vector<String> lista) {
          super();
          this.actividad = actividad;
          this.lista = lista;
          chequeados = new Boolean[lista.size()]; 
          for(int i=0; i<lista.size(); i++){
        	  chequeados[i]= false;
          }
    }

    public View getView(final int position, View convertView, ViewGroup parent) {
          LayoutInflater inflater = actividad.getLayoutInflater();
         
          View view = inflater.inflate(R.layout.elemento_lista_si_no, null, true);
          TextView idPregunta =(TextView)view.findViewById(R.id.idPregunta);
          idPregunta.setText(" ");
         
          TextView Pregunta =(TextView)view.findViewById(R.id.Pregunta);
          Pregunta.setText(lista.elementAt(position));
        
          
          CheckBox check = (CheckBox)view.findViewById(R.id.chkSI_NO);
          check.setChecked((boolean) chequeados[position]);
         
          //ponemos invisible es check de las cabeceras de grupo. 1 8 15 22 29 36 43 	50 57 64
    	  if ((position ==0)||(position ==7)||(position ==14)||(position ==21)||(position ==28)||(position ==35)||
    		 (position ==42)||(position ==49)||(position ==56)||(position ==63)){
    		  		check.setVisibility(View.INVISIBLE);
    		  		Pregunta.setTypeface(Pregunta.getTypeface(), Typeface.BOLD);
    	  }
          
          
          check.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            
  			@Override
  			public void onCheckedChanged(CompoundButton buttonView,boolean isChecked) {
  				
  				if (isChecked){
  						contador++;
  						chequeados[position] = true;
  					}else{
  						contador--;	
  						chequeados[position] = false;
  					}
  								
  		   }
            }); 
          
          
          
          
          return view;
    }

    public int getCount() {
          return lista.size();
    }

    public Object getItem(int arg0) {
          return lista.elementAt(arg0);
    }

    public long getItemId(int position) {
          return position;
    }
    public int getContador() {
        return contador;
    }
}
