package com.example.physiotherapytest;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Vector;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.PathShape;
import android.graphics.drawable.shapes.RectShape;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.media.AudioManager;
import android.media.SoundPool;
import android.os.Bundle;
import android.util.AttributeSet;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.View;

public class VistaCuerpoHumano extends View {
	private String accion = "";
	private float x = 20;
	private float y = 20;
	private Path caminoRojo = new Path();
	private Path caminoAmarillo = new Path();
	private Path caminoGris = new Path();
	private Path caminofecha= new Path();
	private Paint pincelRojo = new Paint();
	private Paint pincelGris = new Paint();
	private Paint pincelAmarillo = new Paint();
	private Paint pincelNegro = new Paint();
	private int colorActual = Color.RED;
	private float xinicial;
	private float yinicial;
	private float xfinal;
    
	
    public VistaCuerpoHumano(Context context, AttributeSet attrs) {
		super(context, attrs);
		pincelRojo.setStyle(Paint.Style.STROKE);
		pincelRojo.setStrokeWidth(10);
		pincelRojo.setColor(Color.RED);
		pincelRojo.setAlpha(200);
		pincelGris.setStyle(Paint.Style.STROKE);
		pincelGris.setStrokeWidth(10);
		pincelGris.setColor(Color.GRAY);
		pincelGris.setAlpha(200);
		pincelAmarillo.setStyle(Paint.Style.STROKE);
		pincelAmarillo.setStrokeWidth(10);
		pincelAmarillo.setColor(Color.YELLOW);
		pincelAmarillo.setAlpha(200);
		pincelNegro.setStyle(Paint.Style.FILL);
		pincelNegro.setColor(Color.BLACK);
		pincelNegro.setStrokeWidth(10);
	}

	public void onDraw(Canvas canvas) {
		if (colorActual == Color.RED) {
			if (accion.equals("pulsar")) {
				caminoRojo.moveTo(x, y);
			}
			if (accion.equals("mover")) {
				caminoRojo.lineTo(x, y);
			}
		}	
		if (colorActual == Color.YELLOW) {
			if (accion.equals("pulsar")) {
				caminoAmarillo.moveTo(x, y);
			}
			if (accion.equals("mover")) {
				caminoAmarillo.lineTo(x, y);
			}
		}
		if (colorActual == Color.GRAY) {
			if (accion.equals("pulsar")){
				caminoGris.moveTo(x, y);
			}
			if (accion.equals("mover")) {
				caminoGris.lineTo(x, y);
			}
		}
		canvas.drawPath(caminoGris, pincelGris);
		canvas.drawPath(caminoAmarillo, pincelAmarillo);
		canvas.drawPath(caminoRojo, pincelRojo);
		caminofecha.moveTo(xinicial, yinicial);
		caminofecha.lineTo(xinicial + 100, yinicial);
		Date fecha = new Date();
     	 SimpleDateFormat formateador = new SimpleDateFormat("dd/MM/yyyy");
		canvas.drawTextOnPath(formateador.format(fecha), caminofecha, 0, 0, pincelNegro);
		
   }


	@Override
	protected void onSizeChanged(int ancho, int alto, int ancho_anter,
			int alto_anter) {
		super.onSizeChanged(ancho, alto, ancho_anter, alto_anter);
		
		xinicial = (ancho*90)/100;
		yinicial = (alto*2/100);
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		super.onTouchEvent(event);

		x = event.getX();
		y = event.getY();
		switch (event.getAction()) {
		case MotionEvent.ACTION_DOWN:
			accion = "pulsar";
			break;
		case MotionEvent.ACTION_MOVE:
			accion = "mover";
			break;
		case MotionEvent.ACTION_UP:
			accion = "levantar";
			break;
		}
		invalidate();
		return true;
	}

	public void setColorActual(int color){
		if (color == Color.RED){
			colorActual = Color.RED;
		}
		if (color == Color.YELLOW){
			colorActual = Color.YELLOW;
		}
		if (color == Color.GRAY){
			colorActual = Color.GRAY;
		}
	}

}
